import { IInteractionTarget, ILayer, ITileLayer, ITileLayerManager, ITileLayerOPtions } from '@antv/l7-core';
import { Tile, TilesetManager } from '@antv/l7-utils';
export default class BaseTileLayer implements ITileLayer {
    get children(): ILayer[];
    type: string;
    sourceLayer: string;
    parent: ILayer;
    initedTileset: boolean;
    tilesetManager: TilesetManager | undefined;
    tileLayerManager: ITileLayerManager;
    scaleField: any;
    private lastViewStates;
    private timer;
    private mapService;
    private layerService;
    private pickColors;
    constructor({ parent, rendererService, mapService, layerService, pickingService, }: ITileLayerOPtions);
    /**
     * 渲染瓦片的图层
     */
    render(): void;
    clearPick(type: string): void;
    /**
     * 清除 select 的选中状态
     */
    clearPickState(): void;
    /**
     * 瓦片图层独立的拾取逻辑
     * @param target
     * @returns
     */
    pickLayers(target: IInteractionTarget): boolean;
    tileLoaded(tile: Tile): void;
    tileError(error: Error): void;
    tileUnLoad(tile: Tile): void;
    tileUpdate(): void;
    protected setPickState(layers: ILayer[]): void;
    private bindSubLayerPick;
    private setHighlight;
    private setSelect;
    private selectFeature;
    private bindSubLayerEvent;
    private initTileSetManager;
    private mapchange;
    private bindTilesetEvent;
    private getCurrentView;
}
